package org.gcube.informationsystem.resourceregistry;

import java.io.IOException;

import org.gcube.informationsystem.context.impl.entities.ContextImpl;
import org.gcube.informationsystem.context.reference.entities.Context;
import org.gcube.informationsystem.resourceregistry.api.exceptions.ResourceRegistryException;
import org.gcube.informationsystem.resourceregistry.contexts.ContextCreator;
import org.gcube.informationsystem.resourceregistry.contexts.entities.ContextManagement;
import org.gcube.informationsystem.resourceregistry.dbinitialization.DatabaseEnvironment;
import org.gcube.informationsystem.utils.ElementMapper;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DataBaseCreator extends ContextTest {
	
	private static Logger logger = LoggerFactory.getLogger(DataBaseCreator.class);
	
	@Test
	public void createDatabase() throws Exception {
		ContextTest.setContextByName(PARENT_DEFAULT_TEST_SCOPE);
		
		logger.debug("Going to create DB");
		String db = DatabaseEnvironment.DB_URI;
		logger.debug("{} created", db);
		
		ContextCreator contextCreator = new ContextCreator();
		contextCreator.all();
		
	}
	
	//@Test
	public void createAllContext() throws Exception {
		ContextTest.setContextByName(PARENT_DEFAULT_TEST_SCOPE);
		
		ContextCreator contextCreator = new ContextCreator();
		contextCreator.all();
		
	}
	
	protected Context create(Context context) throws ResourceRegistryException, IOException {
		ContextManagement contextManagement = new ContextManagement();
		contextManagement.setJson(ElementMapper.marshal(context));
		String contextString = contextManagement.create();
		logger.info("Created {}", contextString);
		Context c = ElementMapper.unmarshal(Context.class, contextString);
		return c;
	}
	
	// @Test
	public void createDevContext() throws Exception {
		Context gcube = new ContextImpl("gcube");
		gcube = create(gcube);
		
		Context devsec = new ContextImpl("devsec");
		devsec.setParent(gcube);
		devsec = create(devsec);
		
		Context devVRE = new ContextImpl("devVRE");
		devVRE.setParent(devsec);
		devVRE = create(devVRE);
		
		Context devNext = new ContextImpl("devNext");
		devNext.setParent(gcube);
		devNext = create(devNext);
		
		Context nextNext = new ContextImpl("NextNext");
		nextNext.setParent(devNext);
		nextNext = create(nextNext);
		
	}
	
}
